### Method

# EDataCal CalCache put_components

since: 3.26

#### Declaration [src]

    gboolean
    e_cal_cache_put_components (
      ECalCache* cal_cache,
      const GSList* components,
      const GSList* extras,
      const GSList* custom_flags,
      ECacheOfflineFlag offline_flag,
      GCancellable* cancellable,
      GError** error
    )

#### Description [src]

Adds a list of `components` into the `cal_cache`. Any existing with the same UID and RID are replaced.

If `extras` is not `NULL`, its length should be the same as the length of the `components`. Similarly the non-NULL `custom_flags` length should be the same as the length of the `components`.

Available since: 3.26

#### Parameters

`components`

  Type: A list of `None`

  A `GSList` of `ECalComponent` to put into the `cal_cache`.

  The data is owned by the caller of the method.

`extras`

  Type: A list of `utf8`

  Optional extra data to store in association with the `components`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.
  Each element is a NUL terminated UTF-8 string.

`custom_flags`

  Type: A list of `guint32`

  Optional custom flags to use for the `components`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`offline_flag`

  Type: `ECacheOfflineFlag`

  One of `ECacheOfflineFlag`, whether putting these components in offline.

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the method.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the method if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `gboolean`

Whether succeeded.